﻿'
' Created by SharpDevelop.
' User: dj
' Date: 12/9/2011
' Time: 5:58 PM
' 
' To change this template use Tools | Options | Coding | Edit Standard Headers.

Imports System
Imports System.Diagnostics

Imports System.Windows.Forms
Imports System.Text
Imports System.Timers
'Imports System.Text.RegularExpressions
'Imports System.Xml
Imports System.Threading
'Imports System.Reflection
'Imports System.Drawing
Imports System.IO
'Imports System.IO.Ports


	Public Enum LogMode
		Silent
		Flush
		Show
	End Enum

'Module MyLogging
Public Class Logger
'make this accessible to entire Module by putting it here:

'	Public Shared Sub MsgOut(msg As String)
'		Msgbox(msg)
'		Console.Write(msg)
''		If waitin Then Console.ReadKey(True)
'	End Sub

'display error message and write to log:
	Public Shared ErrPause As Boolean = True
	Public Shared Sub ReportError(where As String)
		ReportError(where, Nothing)
	End Sub
	Public Shared Sub ReportError(where As String, exc As Exception)
'NOTE to style critics: I hate line numbers but I also hate cluttering up source code with a lot of state/location info
'Line#s appear to be the most compact way to show the location of errors (since VB.NET doesn't have a __LINE__ macro like the C++ preprocessor), and there is no additional overhead
'UPDATE: line#s are available if a .PDB file is in the same folder; this is preferred, but not guaranteed so VB line#s are still a fall-back
		If Erl <> 0 Then where &= "@" & Erl 'show line# if present (VB only)
		Dim msg As String
		If exc IsNot Nothing Then
			msg = String.Format(CType(IIf(Err.Number <> 0, "{0} (error {1} {2} in {3})", "{2} (in {3})"), String), Err.Description, Err.Number, exc.Message, where)
'			Dim from As StackFrame = New StackFrame(0, True) '(New StackTrace(exc, True)).Getframe(0) 'stk As New StackTrace(exc, True)
			Dim from As StackFrame = (New StackTrace(exc, True)).Getframe(0)
			LogMsg(String.Format("ERROR: {0} from {1}:{2}{3}{4}", msg, System.IO.Path.GetFileNameWithoutExtension(from.GetFileName()), from.GetFileLineNumber(), vbCRLF, exc.StackTrace), LogMode.Flush)
			If exc.InnerException IsNot Nothing Then
				from = (New StackTrace(exc.InnerException, True)).Getframe(0) 'stk As New StackTrace(exc, True)
				LogMsg(String.Format("Inner exc: {0} from {1}:{2}", exc.InnerException.Message, System.IO.Path.GetFileNameWithoutExtension(from.GetFileName()), from.GetFileLineNumber()), LogMode.Flush)
			End If
		else
			msg = String.Format(CType(IIf(Err.Number <> 0, "{0} (error {1} in {2})", "{0} (in {2})"), String), Err.Description, Err.Number, where)
			LogMsg(String.Format("ERROR: {0}", msg), LogMode.Flush)
		End If
		If Not ErrPause Then Return
'this isn't quite right yet, but at least it stops
'TODO: make all threads wait (to prevent a lot of windows during sequence execution)
		If MessageBox.Show(String.Format("{0}{1}Continue execution?", msg, vbCrLf), "ERROR", System.Windows.Forms.MessageBoxButtons.OKCancel, System.Windows.Forms.MessageBoxIcon.Question) <> DialogResult.OK Then Thread.CurrentThread.Abort
	End Sub

'dump a byte array as hex values:
	Public Shared Function DumpHex(buf As Byte(), StartOfs As Integer, ActualLen As Integer, ByVal MaxLen As Integer) As String
		Return DumpHex(buf, StartOfs, ActualLen, MaxLen, False)
	End Function
	Public Shared Function DumpHex(buf As Byte(), StartOfs As Integer, ActualLen As Integer, ByVal MaxLen As Integer, asrgb As Boolean) As String
		Dim hexbuf As New StringBuilder()
		Dim prevcount As Integer = 0, prevrgbcount As Integer = 0 ', trunc As Boolean = False, prevbyte As Byte
'		While ActualLen > 1
'			If buf(ActualLen - 1) <> 0 Then Exit While
'			trunc = True
'			ActualLen -= 1
'		End While
		MaxLen = Math.Min(Math.Min(StartOfs + ActualLen , StartOfs + MaxLen), buf.Length) 'limit amount of data to show
		For i As Integer = StartOfs To MaxLen - 1
'			If i > MaxLen Then trunc = True: Exit For
#If False
			If (i > StartOfs) And (i < MaxLen - 1) AndAlso (buf(i) = buf(i - 1)) Then prevcount += 1: Continue For
			If prevcount > 2 Then
				hexbuf.AppendFormat("*{0} ", prevcount)
			ElseIf prevcount = 2 Then 'skip the fancy notation
				hexbuf.AppendFormat("x{0:X2} ", buf(i - 1))
			End If
			hexbuf.AppendFormat("x{0:X2} ", buf(i))
			If (i = MaxLen - 1) And (i < ActualLen - 1) Then hexbuf.Append(" ...")
'			prevbyte = buf(i)
			prevcount = 1
#Else
			If i <= MaxLen - 3*2 Then
				If asrgb Or (buf(i) <> buf(i + 1)) Or (buf(i) <> buf(i + 2)) Then 'maybe RGB value
					If (buf(i) = buf(i + 3)) And (buf(i + 1) = buf(i + 4)) And (buf(i + 2) = buf(i + 5)) Then
						prevrgbcount += 1: i += 3-1
						Continue For
					End If
				End If
			End If
			If prevrgbcount > 0 Then 'flush repeating RGB value
				hexbuf.AppendFormat("[x{0:X2} x{1:X2} x{2:X2}] *{3} ", buf(i - 3), buf(i - 2), buf(i - 1), prevrgbcount + 1)
				prevrgbcount = 0: i += 3-1
				Continue For
			End If
			If (i <= MaxLen - 1*2) AndAlso (buf(i) = buf(i + 1)) Then prevcount += 1: Continue For
			If prevcount > 2 Then 'flush repeating value
				hexbuf.AppendFormat("x{0:X2} *{1} ", buf(i - 1), prevcount + 1)
				prevcount = 0
				Continue For
			End If
			hexbuf.AppendFormat("x{0:X2} ", buf(i)) 'non-repeating value
			If (i = MaxLen - 1) And (i < ActualLen - 1) Then hexbuf.Append(" ...")
#End If
		Next i
'		If trunc Then hexbuf.Append(" ...")
		if hexbuf.Length = 0 then hexbuf.AppendFormat("(no dump: {0}..{1} actual {2})", startofs, maxlen-1, actuallen)
		Return hexbuf.ToString
	End Function

'write message to log file with relative timestamp:
'Make this one public so it can be called from test code.
	Private Shared ReadOnly LogFileContention As New Object 'serialize writes to log file to avoid threading problems
	Public Shared WantTrace As Boolean = False
	Public Shared LogFile As String = String.Empty
	Private Shared m_logbuf As New StringBuilder
	Private Shared WithEvents m_delay As System.Timers.Timer = Nothing 'System.Windows.Forms.Timer = Nothing
	Private Shared m_StartTime As Date 'log entry times are relative to start of execution
	Public Shared Property StartTime As Date
		Get
			Return m_StartTime
		End Get
		Set(newval As Date)
			m_StartTIme = newval
			m_seqnum = 0
		End Set
	End Property
	Private Shared m_seqnum As Long = 0 'log entry sequence# (useful to check for missing/overwritten entries)
	Public Shared NoPopup As Boolean = False 'inhibit popup display
	Public Shared Sub LogMsg(buf As String)
		 LogMsg(buf, LogMode.Show)
	End Sub
	Public Shared Sub LogMsg(buf As String, mode As LogMode)
		'On Error Resume Next 'just ignore errors if they occur, rather than getting into an infinite loop
'		If String.IsNullOrEmpty(Me.m_logfile) Then Exit Sub
		Dim tdiff As Long = Elapsed() 'TimeSpan = DateTime.Now.Subtract(Me.m_starttime)
'#Error: threading problem With LogMsg
		Monitor.Enter(LogFileContention)
		m_seqnum += 1
#If True 'TODO: file name + line# are broken
		Dim from As StackFrame() = (New StackTrace(0, True)).GetFrames() 'start at current frame, include line#s
		For i As Integer = 1 To from.Length
			If System.IO.Path.GetFileName(from(i - 1).GetFileName()) = "Logging.vb" Then Continue For 'don't report self
			If from(i - 1).GetMethod().Name.Equals("LogMsg") Then Continue For 'kludge; fall-back in case above no worky
			If String.IsNullOrEmpty(from(i - 1).GetFileName()) Then Exit For 'not getting any data
			If (from(i - 1).GetFileLineNumber() = 0) OrElse String.IsNullOrEmpty(from(i - 1).GetFileName()) Then 'missing full debug info
				buf &= String.Format("  @{0}", from(i - 1).GetMethod().Name)
			Else
				buf &= String.Format("  @{0}.{1}:{2}", System.IO.Path.GetFileNameWithoutExtension(from(i - 1).GetFileName()), from(i - 1).GetMethod().Name, from(i - 1).GetFileLineNumber())
			End If
			Exit For
		Next i
#Else
		Dim from As StackFrame = New StackFrame(1, True)
		If from.GetFileName() = "Logging.vb" Then from = New StackFrame(2, True) 'don't report self
		If from.GetFileName() = "Logging.vb" Then from = New StackFrame(3, True) 'don't report self
		buf &= String.Format("  @{0}.{1}:{2}", from.GetFileName(), from.GetMethod().Name, from.GetFileLineNumber())
#End If
'		Dim msg as String = String.Format("[T+{0:D}:{1:D2}:{2:D2}.{3:D3}] " & buf & ChrW(13) & ChrW(10), New Object() { tdiff.Hours, tdiff.Minutes, tdiff.Seconds, tdiff.Milliseconds})
'		Dim msg as String = String.Format("[{0} T+{1:D}:{2:D2}:{3:D2}.{4:D3}] {5}{6}", Me.m_seqnum, tdiff.Hours, tdiff.Minutes, tdiff.Seconds, tdiff.Milliseconds, buf, vbCRLF)
		Dim msg as String = String.Format("[{0} T+{1:D2}.{2:D3}] {3}{4}", m_seqnum, tdiff\1000, tdiff Mod 1000, buf, vbCRLF)
'		Dim outstream As filestream = File.open(Me.m_logfile, FileMode.OpenOrCreate, FileAccess.Write, FileShare.ReadWrite)
'		Dim buf As Byte() = system.Text.Encoding.Default.GetBytes(msg)
'		If outstream.length > 0 Then stream.position = stream.length - 1
'		outstream.write(buf, 0, msg.length - 1)
'		outstream.close
		m_logbuf.Append(msg)
		If (m_logbuf.Length < 2048) And (mode <> LogMode.Flush) Then
			If (mode <> LogMode.Silent) And String.IsNullOrEmpty(LogFile) Then 'And Not NoPopup Then
				If m_delay Is Nothing Then
					m_delay = New System.Timers.Timer(3000) '.Windows.Forms.Timer() 'msec
					m_delay.AutoReset = False
					m_delay.Enabled = True
				End If
'				m_delay.Enabled = False: m_delay.Enabled = True 'restart
				m_delay.Start()
			End If
			Monitor.Exit(LogFileContention)
			Return
		End If
		msg = m_logbuf.ToString()
		m_logbuf.Length = 0 'New StringBuilder
		If Not String.IsNullOrEmpty(LogFile) Then
			System.IO.File.AppendAllText(LogFile, msg) 'AppendAllText is NOT THREAD-SAFE, so access must be serialized
		End If
		If m_delay IsNot Nothing Then m_delay.Stop() 'm_delay.Enabled = False
		Monitor.Exit(LogFileContention)
		Console.Write(msg)
'		Msgbox(msg)
		If String.IsNullOrEmpty(LogFile) Then
			MessageBox.Show(msg, String.Format("{0} DEBUG", LeftOf(Reflection.Assembly.GetCallingAssembly().FullName, ",")), MessageBoxButtons.OK, MessageBoxIcon.Information) 'Reflection.Assembly.GetCallingAssembly().GetName()
		End If
	End Sub
	Private Shared Sub flushlog(sender As Object, ea As ElapsedEventArgs) Handles m_delay.Elapsed
		LogMsg(String.Empty, LogMode.Flush)
	End Sub

	Public Shared Function LeftOf(str As String, delim As String) As String
		Dim ofs As Integer = str.IndexOf(delim, System.StringComparison.OrdinalIgnoreCase)
		If ofs = -1 Then Return str
		Return str.Substring(0, ofs)
	End Function

	Public Shared Function Elapsed() As Long
		Return CLng(DateTime.Now.Subtract(StartTime).TotalMilliseconds)
	End Function
'End Module
End Class
'#End Region


'#Region "Other utils"
'Module MyUtils
'	Public Function SafeDirectCast(thing As Object, wanttype As Type) As Type
'		Try
'			Return DirectCast(thing, wanttype)
'		Catch exc As Exception
'			Return Nothing
'		End Try
'	End Function
'End Module
'#End Region