﻿'
' Created by SharpDevelop.
' User: dj
' Date: 12/9/2011
' Time: 5:52 PM
' 
' To change this template use Tools | Options | Coding | Edit Standard Headers.

Imports System
'Imports System.Windows.Forms
Imports System.Text
Imports System.Text.RegularExpressions
Imports System.Xml
'Imports System.Threading
Imports System.Reflection
'Imports System.Drawing
'Imports System.IO
'Imports System.IO.Ports

Namespace FxGen

'PlugIn list management:
'This allows a list of plug-ins to be manipulated more easily.
Public MustInherit Partial Class FxGenPluginBase 'MustInherit PluginWrapper
'cumulative properties:
	Private Shared m_plugins As New List(Of FxGenPluginBase)
	Public Shared MinChannel As Integer = Int32.MaxValue, MaxChannel As Integer = Int32.MinValue

	Public Function AllocFramebuf() As Byte()
		Dim numch_m1 As Integer = MaxChannel - MinChannel '#channels - 1
'		msgbox(string.Format("aloc frame buf {0}", PluginWrapper.MaxChannel - PluginWrapper.MinChannel))
'		Return New Byte(MaxChannel - MinChannel +2) {} 'kludge: allow trailing B + G on RGB values
		Return New Byte(numch_m1 + 2 - (numch_m1 Mod 3)) {} 'allow trailing B + G on RGB values
	End Function

	Public MustOverride Sub GetFxChannels(name As String, PluginTag As String, dict As Dictionary(Of Integer, ColoredString)) '//Vixen.IExecutable virtseq, XmlNode hostnode, Dictionary<int, string> dict) //string PluginTag, string name) //Vixen.IExecutable virtseq, XmlNode hostnode)
	Public Function GetPluginFxChannels(hostnode As XmlNode) As Dictionary(Of Integer, ColoredString)
		Dim fxch as New Dictionary(Of Integer, ColoredString)
		If Logger.WantTrace Then Logger.LogMsg("get plugin tags")
		For Each vopi As Vixen.OutputPlugin In Me.VixenInfo.Seq.PlugInData.GetOutputPlugins
			Dim plugnode As XmlNode = hostnode.SelectSingleNode(String.Format("{0}[@id='{1}']", MyPlugins, vopi.Id.ToString))
			'If logger.WantTrace Then logger.LogMsg(String.Format("got plug node {0}[@id='{1}'] from {2}? {3}", MyPlugins, vopi.Id, hostnode.OuterXml, plugnode IsNot Nothing))
			If plugnode Is Nothing Then Continue For
			'If Logger.WantTrace And (plugnode.Attributes("name") IsNot Nothing) Then Logger.LogMsg(String.Format("virt plugin name = {0}", plugnode.Attributes("name").Value))
			'If Logger.WantTrace And (plugnode.Attributes("id") IsNot Nothing) Then Logger.LogMsg(String.Format("virt plugin id = {0}", plugnode.Attributes("id").Value))
			'If Logger.WantTrace And (plugnode.Attributes("from") IsNot Nothing) Then Logger.LogMsg(String.Format("virt plugin from = {0}", plugnode.Attributes("from").Value))
			'If Logger.WantTrace And (plugnode.Attributes("to") IsNot Nothing) Then Logger.LogMsg(String.Format("virt plugin to = {0}", plugnode.Attributes("to").Value))
			Dim defname As String = String.Format("{0}:{1} [{2}..{3}]", plugnode.Attributes("name").Value, plugnode.Attributes("id").Value, plugnode.Attributes("from").Value, plugnode.Attributes("to").Value) 'default name
			If Logger.WantTrace Then Logger.LogMsg(String.Format("virt plugin def name = {0}", defname))
			GetFxChannels(defname, plugnode.SelectSingleNode("Tag").InnerText, fxch) 'Me.m_virtseq, Vixen.Xml.GetNodeAlways(Me.m_setupNode, MyPluginsNode, String.Empty))
			If Logger.WantTrace Then Logger.LogMsg(String.Format("after {0} have {1} ch", vopi.Name, fxch.Count))
		Next vopi
		Return fxch
	End Function
#If False 'breaks typelib???? 'moved to CustomF
	Private Shared nametag As New Regex("name:\\s*([A-Za-z0-9_]+)")
	Private Shared functag As New Regex("func:\\s*(\\d+)")
	Private Shared paramtag As New Regex("param:\\s*(\\d+)")
	Private Shared colortag As New Regex("color:\\s*\\[(\\d+),\\s*\\d+,\\s*\\d+,\\s*\\d+\\]") 'A, R, G, B
	Private Shared echotag As New Regex("echo:\\s*\\[(\\d+),")
	Private Shared texttag As New Regex("text:\\s*(\\d+)")
	Public Shared Function GetPluginTags(virtseq As Vixen.IExecutable, hostnode As XmlNode) As Dictionary(Of Integer, String)
		Dim dict As New Dictionary(Of Integer, String)
		For Each vopi As Vixen.OutputPlugin In virtseq.PlugInData.GetOutputPlugins
			Dim plugnode As XmlNode = hostnode.SelectSingleNode(String.Format("{0}[@id='{1}']", MyPlugins, vopi.Id.ToString))
			Dim plugintag As String = plugnode.SelectSingleNode("Tag").InnerText
			Dim name As String = String.Format("{0}:{1} [{2}..{3}]", vopi.Name, vopi.Id, vopi.ChannelFrom, vopi.ChannelTo) 'default name
			Dim parts As Match = nametag.Match(PluginTag)
			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then name = parts.Groups(1).Value
			parts = functag.Match(PluginTag)
			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then
				Dim chnum As Integer = Convert.ToInt32(parts.Groups(1).Value)
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxFunc #{1}", name, chnum))
			End If
			parts = paramtag.Match(PluginTag)
			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then
				Dim chnum As Integer = Convert.ToInt32(parts.Groups(1).Value)
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxParam #{1}", name, chnum))
			End If
			parts = colortag.Match(PluginTag)
			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then
				Dim chnum As Integer = Convert.ToInt32(parts.Groups(1).Value)
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxColor.A #{1}", name, chnum))
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxColor.R #{1}", name, chnum))
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxColor.G #{1}", name, chnum))
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxColor.B #{1}", name, chnum))
			End If
'			parts = echotag.Match(PluginTag)
'			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then
'				Dim chnum As Integer = Convert.ToInt32(parts.Groups(1).Value)
'				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxEcho #{1}", name, chnum))
'			End If
			parts = texttag.Match(PluginTag)
			If parts.Success AndAlso (parts.Groups.Count = 1+1) Then
				Dim chnum As Integer = Convert.ToInt32(parts.Groups(1).Value)
				If Not dict.ContainsKey(chnum) Then dict.Add(chnum, String.Format("{0} FxText #{1}", name, chnum))
			End If
		Next vopi
		Return dict
	End Function
#End If

	Public Function LoadAllPlugins(virtseq As Vixen.IExecutable, hostnode As XmlNode) As Boolean
		m_plugins.Clear() 'start with empty list
'		PluginWrapper.Logger = AddressOf XSPlayer.LogMsg
'		msgbox("set up virt ser port")
		For Each vopi As Vixen.OutputPlugin In virtseq.PlugInData.GetOutputPlugins
'			If vopi.Name <> plugin.ToString Then Continue For 'looking for plug-in by name
'			Dim piw As New PluginWrapper(virtseq, vopi, virtseq.PlugInData.GetPlugInData(vopi.Id.ToString()), hostnode.SelectSingleNode(String.Format("Plugin[@id='{0}']", Mvopi.Id.ToString)))
'			Dim ctor As ConstructorInfo = Me.GetType().GetConstructor(New Type() { virtseq.GetType(), vopi.GetType(), virtseq.PlugInData.GetPlugInData(vopi.Id.ToString()).GetType(), GetType(XmlNode) })
			Dim ctor As ConstructorInfo = Me.GetType().GetConstructor(New Type() {}) '{ GetType(Vixen.IExecutable), GetType(Vixen.OutputPlugin), GetType(XmlNode), GetType(XmlNode) }) 'ctor defined in PluginWrapper section (below)
'			Dim ctors As ConstructorInfo() = Me.GetType().GetConstructors()
'			dim dj as String = ""
'			For i As Integer = 1 To ctors.length
'				Dim params As ParameterInfo() = ctors(i - 1).GetParameters()
'				dj &= ", " & ctors(i - 1).IsPublic & ":" & ctors(i - 1).Name & " " & params.Length & " params"
'			Next i
'			Logger.LogMsg(ctors.Length & " ctors for " & Me.GetType().Name & ": " & dj)
'			Logger.LogMsg(String.Format("got {0} ctor for {1} ({2}, {3}, {4}, {5}? {6}", Me.GetType().FullName, vopi.Name, virtseq.GetType().FullName, vopi.GetType().FullName, virtseq.PlugInData.GetPlugInData(vopi.Id.ToString()).GetType().FullName, GetType(XmlNode).FullName, ctor IsNot Nothing))
			If ctor Is Nothing Then Continue For
			Dim piw As FxGenPluginBase = DirectCast(ctor.Invoke(new Type() {}), FxGenPluginBase) 'new Object() { virtseq, vopi, virtseq.PlugInData.GetPlugInData(vopi.Id.ToString()), hostnode.SelectSingleNode(String.Format("VirtPlugin[@id='{0}']", vopi.Id.ToString))}), FxGenPluginBase)
			If piw Is Nothing Then Continue For
			piw.MyNew(virtseq, vopi, virtseq.PlugInData.GetPlugInData(vopi.Id.ToString()), hostnode.SelectSingleNode(String.Format("{0}[@id='{1}']", MyPlugins, vopi.Id.ToString)))
'alloc frame buffer even for disabled plugins (avoids conditional offsets):
			MinChannel = Math.Min(piw.StartChannel, MinChannel)
			MaxChannel = Math.Max(piw.EndChannel, MaxChannel)
			If Not piw.Enabled Then Continue For
'//			this.m_chmap = new MyChannelMapper();
'			piw.PixelType = "RGB"
'			piw.Geometry = new System.Drawing.Size(16, 15)
'			piw.ChannelOrder = "LR-BT"
'			piw.Canvas = piw.ChannelMapper.Map(framebuf) '//GDI bitmap to draw on
'			piw.Graphics = Graphics.FromImage(piw.Canvas)
'			piw.Rect = new Rectangle(0, 0, piw.ChannelMapper.Geometry.Width, piw.ChannelMapper.Geometry.Height);
'//			this.m_macofs = (int)MyVirtChannels.MacroFunc;
'//			this.m_frbofs = frbuf.StartOfs;
'//			this.m_frblen = frbuf.AvailLen;
'//		 (int)MyVirtChannels.GdoorRChofs, (int)MyVirtChannels.GdoorRNumch, "RGB", new Size(16, 15), "LR-BT");
			m_plugins.Add(piw)
		Next vopi
		Return m_plugins.Count > 0
	End Function

	Public Sub ShowAllPlugs(setup As FxGen_base.VixFxGenSetup)
		Dim first As Integer = 0
		For i As Integer = 1 To m_plugins.Count 'sorted by name
14:			If Logger.WantTrace Then Logger.LogMsg(String.Format("add plugin#{0}/{1} '{2}' to listbox", i, m_plugins.Count, m_plugins(i - 1).Desc)) '.Keys(i - 1)))
15:			setup.PluginNames(i - 1) = m_plugins(i - 1).Desc '.Keys(i - 1)
16:			setup.PluginSelected(i - 1) = m_plugins(i - 1).WantFx '.Enabled '.Values(i - 1).Selected '.VirtEnabled
17:			setup.PluginChannels(i - 1) = m_plugins(i - 1).NumChannels
			If m_plugins(i - 1).WantFx And (first = 0) Then first = i
'17:			dlg.PluginChannels(i - 1) = New Size(Me.m_plugins(i - 1).StartChannel, Me.m_plugins(i - 1).EndChannel)
			Try 'might have invalid residue from previous virt profile
18:				If Logger.WantTrace Then Logger.LogMsg(String.Format("set wantfx {0}, pixtype {1}, canvas {2}, chord {3}, tag {4} for plugin[{5}/{6}] {7}", m_plugins(i - 1).WantFx, m_plugins(i - 1).PixelType, Size2String(m_plugins(i - 1).Geometry), m_plugins(i - 1).ChannelOrder, m_plugins(i - 1).PluginTag, i, m_plugins.Count, m_plugins(i - 1).Desc))
'				setup.PixelType(i - 1) = String.Empty 'force internal update
19:				setup.PixelType(i - 1) = m_plugins(i - 1).PixelType
'				setup.CanvasSize(i - 1) = String.Empty 'force internal update
20:				setup.CanvasSize(i - 1) = Size2String(m_plugins(i - 1).Geometry) 'FxGenPluginBase.
'				setup.ChannelOrder(i - 1) = String.Empty 'force internal update
21:				setup.ChannelOrder(i - 1) = m_plugins(i - 1).ChannelOrder
				setup.PluginTag(i - 1) = m_plugins(i - 1).PluginTag
			Catch exc As Exception
				Logger.ReportError("PluginSetup", exc)
			End try
		Next i
		If first = 0 Then Return 'first = 1
		setup.PluginSelected(first - 1) = m_plugins(first - 1).WantFx 'leave first one selected
'		setup.CanvasSize(first) = Size2String(m_plugins(first).Geometry) 'leave first one selected
'		setup.ChannelOrder(first) = m_plugins(first).ChannelOrder 'leave first one selected
		setup.IsDirty = False
	End Sub

	Public Sub StartAllPlugins() 'seq As Vixen.IExecutable)
		For Each vopiw As FxGenPluginBase In m_plugins
			vopiw.FrameBuf = Me.FrameBuf 'share frame buf with all plug-ins in case channels overlap
			vopiw.VixenInfo = Me.VixenInfo 'give access to sequence info
			vopiw.Startup()
		Next vopiw
	End Sub

	Public MustOverride Function FxGen(frame As Integer, timestamp As Integer, framebuf As ByteRange) As Boolean 'seq As Vixen.EventSequence, 
	Public Function RenderAllEffects(frame As Integer, timestamp As Integer) As Boolean '(seq As Vixen.EventSequence, frame As Integer, timestamp As Integer, framebuf As Byte()) As Boolean
		Dim dirty As Boolean = False
		Dim outbuf As New ByteRange(Me.FrameBuf, 0, 0) 'NOTE: this allows fx funcs to see entire frame buf if they want to look outside their own piece
 'Logger.LogMsg("here1")
'NOTE: collection gets modified somewhere (another thread?), so explicitly iterate thru list to avoid "collection modified" exceptions
'		For Each vopiw As FxGenPluginBase In m_plugins
		For i As Integer = m_plugins.Count To 1 Step -1
 'Logger.LogMsg("here2 " & i & "/" & m_plugins.Count)
			Dim vopiw As FxGenPluginBase = m_plugins(i - 1)
			If vopiw Is Nothing Then Continue For 'disposed already? then skip it
			If Not vopiw.WantFx Then Continue For
			outbuf.StartOfs = vopiw.StartChannel -1
			outbuf.AvailLen = vopiw.EndChannel - vopiw.StartChannel +1
'//			this.m_canvas = this.m_chmap.Map(frbuf); //GDI bitmap to draw on
			Try
 'Logger.LogMsg("here3 " & outbuf.StartOfs & "..+" & outbuf.AvailLen)
				If Not vopiw.FxGen(frame, timestamp, outbuf) Then Continue For 'render current frame
				if frame <> Integer.MaxValue then vopiw.Unmap(vopiw.Canvas, outbuf) '//refresh prop channel values from GDI canvas so output plug-ins can send to controllers
				dirty = True
			Catch exc As Exception
				If Logger.WantTrace Then Logger.LogMsg(String.Format("can't render plugin: {0}", exc.ToString))
			End Try
		Next i 'vopiw
		Return dirty
	End Function

	Public Sub SendAllPlugins(frbuf As Byte()) ', frame As Integer) 'channels As Byte())
'		Try 'try to avoid "collection modified" errors at end of sequence
'NOTE: collection gets modified somewhere (another thread?), so explicitly iterate thru list to avoid "collection modified" exceptions
'			For Each vopiw As FxGenPluginBase In m_plugins
			For i As Integer = m_plugins.Count To 1 Step -1
				Dim vopiw As FxGenPluginBase = m_plugins(i - 1)
				Try
					If vopiw IsNot Nothing Then vopiw.SendEvent(frbuf)
				Catch exc As Exception
					If Logger.WantTrace Then Logger.LogMsg(String.Format("can't send evt to plugin: {0}", exc.ToString))
				End Try
			Next i 'vopiw
'		Catch exc As Exception
'			If Logger.WantTrace Then Logger.LogMsg(String.Format("exc during SendAllPlugins: {0}", exc.ToString))
'		End Try
	End Sub

	Public Sub StopAllPlugins() 'seq As Vixen.IExecutable)
'		On Error Resume Next 'try to avoid "collection modified" errors at end of sequence
'		Try 'try to avoid "collection modified" errors at end of sequence
'NOTE: collection gets modified somewhere (another thread?), so explicitly iterate thru list to avoid "collection modified" exceptions
'			For Each vopiw As FxGenPluginBase In m_plugins
			For i As Integer = m_plugins.Count To 1 Step -1
				Dim vopiw As FxGenPluginBase = m_plugins(i - 1)
				Try
					If vopiw IsNot Nothing Then vopiw.Shutdown()
				Catch exc As Exception
					If Logger.WantTrace Then Logger.LogMsg(String.Format("can't stop plugin: {0}", exc.ToString))
				End Try
				m_plugins(i - 1) = Nothing
			Next i 'vopiw
'		Catch exc As Exception
'			If Logger.WantTrace Then Logger.LogMsg(String.Format("exc during StopAllPlugins: {0}", exc.ToString))
'		End Try
		'all plug-ins should be gone now; reinit counts to avoid stray data for next time:
		'(was causing index out of bounds if prev seq had more channels than this one)
		MinChannel = Int32.MaxValue
		MaxChannel = Int32.MinValue
	End Sub
End Class


'PlugIn wrapper:
'This augments Vixen plug-ins with additional data and behavior.
Public Partial Class FxGenPluginBase 'MustInherit PluginWrapper
	Private m_node As XmlNode
	Private m_seq As Vixen.IExecutable '.EventSequence
	Private m_vopi As Vixen.OutputPlugin
	Private m_OutputPlugin As Vixen.IEventDrivenOutputPlugIn '.OutputPlugin
'props from virtual seq/profile:
	Public Desc As String
	Public Enabled As Boolean
	Public StartChannel As Integer, EndChannel As Integer
'	Public ReadOnly Property NumChannels As Integer
'		Get
'			Return Me.EndChannel - Me.StartChannel +1
'		End Get
'	End Property
	
'props from host seq/profile:
'	Public MustOverride ReadOnly Property ChannelMapper As ChannelMapperBase '= Nothing
'	Public WantFx As Boolean
'	Public PixelType As String
'	Public Geometry As Drawing.Size
'	Public ChannelOrder As String

'	Public Shared MinChannel As Integer = Int32.MaxValue, MaxChannel As Integer = 0
'		Private m_Buffer As Byte()

'state info:
	Private m_inff As Integer = 0
	Private m_inbuf(2 -1)() As Byte 'alternating buffers for more efficient dedup
	Private m_childForm As Windows.Forms.Form = Nothing

'	Delegate Function GetAndClearOutbufLen(clear As Boolean) As Integer
'	Private m_getoutlen As GetAndClearOutbufLen = Nothing
'explanation of interface ref problem:
'http://www.yoda.arachsys.com/csharp/plugin.html
'	Private m_outhook As XSPlayer.IOutbufHook = Nothing
'	Private m_outhook1 As object = nothing 'Renard.XSPlayer.IOutbufHook = Nothing
'	Private m_outhook2 As RenardChipiplexer_21.XSPlayer.IOutbufHook = Nothing
'	Private m_outhook3 As RenardRGB_21.XSPlayer.IOutbufHook = Nothing
'	Public Outbuf As Byte() = New Byte(BufSize(115200, 100)) {} 'CInt(115200/10/(1000/100))) {} 'max output size at given baud rate and frame interval
'	Public Outlen As Integer = 0

	Private Shared MyExe As String = Process.GetCurrentProcess().MainModule.FileName
'NOTE: can't use "New" here because LoadAllPlugins (above) sees the default ctor and not this one
	Sub MyNew(seq As Vixen.IExecutable, vopi As Vixen.OutputPlugin, virtnode As XmlNode, hostnode As XmlNode)
		Me.m_seq = seq 'NOTE: can be seq or prof
'		Me.m_OutputPlugin = DirectCast(vopi, Vixen.IEventDrivenOutputPlugIn)
		Me.m_node = virtnode
		Me.m_vopi = vopi
'		Dim name As String = node.Attributes("name").InnerText
'		Dim id As Integer = Integer.Parse("0" & node.Attributes("id").InnerText)
'		Dim stchannel as Integer = Integer.Parse("0" & node.Attributes("from").InnerText) '1-based
'		Dim enchannel As Integer = Integer.Parse("0" & node.Attributes("to").InnerText) '1-based
		Me.StartChannel = Integer.Parse("0" & virtnode.Attributes("from").InnerText) '1-based
		Me.EndChannel = Integer.Parse("0" & virtnode.Attributes("to").InnerText) '1-based
		Me.NumChannels = Me.EndChannel - Me.StartChannel +1
'			Me.m_Buffer = New Byte(Me.m_EndChannel - Me.m_StartChannel)
		Me.Enabled = Boolean.Parse(virtnode.Attributes("enabled").InnerText)
'		New Vixen.OutputPlugin(name, id, enabled, Me.m_StartChannel, Me.m_EndChannel)
'		Me.m_OutputPlugin = edopi 'DirectCast(Activator.CreateInstance(vopi.GetType(), New Object() {name, id, enabled, Me.m_StartChannel, Me.m_EndChannel}), Vixen.IEventDrivenOutputPlugIn)
		If Not Me.Enabled Then Return 'don't need to go further for this one
'		If (hostnode IsNot Nothing) AndAlso Boolean.Parse(hostnode.SelectSingleNode("WantFx").InnerText) Then Me.ChannelMapper = New 
		If hostnode IsNot Nothing Then
			Me.WantFx = CBool(hostnode.SelectSingleNode("WantFx").InnerText)
			Me.PixelType = hostnode.SelectSingleNode("PixelType").InnerText
			Me.Geometry = String2Size(hostnode.SelectSingleNode("Geometry").InnerText)
			Me.ChannelOrder = hostnode.SelectSingleNode("ChannelOrder").InnerText
			Me.PluginTag = hostnode.SelectSingleNode("Tag").InnerText
			If Logger.WantTrace Then Logger.LogMsg(String.Format("got pixtype {0}, geom {1}, chorder {2}, tag '{3}' for plug-in {4} '{5}'", Me.PixelType, Me.Geometry, Me.ChannelOrder, Me.PluginTag, virtnode.Attributes("id").Value, vopi.Name))
		End If
'		MinChannel = Math.Min(Me.StartChannel, MinChannel)
'		MaxChannel = Math.Max(Me.EndChannel, MaxChannel)

#If False 'use this for stepping into plug-ins; opens known plug-ins only (must have ref in project)
		If System.IO.Path.GetFileNameWithoutExtension(myexe) <> "Vixen" Then 'easier debug
			Select Case True 'vopi.Name
				Case vopi.Name = "Adjustable preview":
					Me.m_OutputPlugin = New Preview.Preview()
					Return
				Case vopi.Name = "Renard Dimmer (modified)":
					Me.m_OutputPlugin = New Renard.Renard()
	'				FindType(Me.m_OutputPlugin, "VirtualSerialPort").GetMethod("SetBuffer").Invoke(((Me.Outbuf, 0, Me.Outbuf.Length) 'namespace is undefined by default for C# classes
	'				Me.m_getoutlen = XSPlayee.VirtualSerialPort.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length)
					Return
				Case vopi.Name = "Grid Editor":
					Me.m_OutputPlugin = New VixenGridEditor_21.VixenGridEditorPlugin()
					Return
#If false 'BROKEN; Not XSPLAYER 'only need this one for XSPlayer, not for self/debug
'				Case vopi.Name.StartsWith("FxGen "):
'					Me.m_OutputPlugin = New FxGen_21.FxGen.VixFxGenPlugin()
''					Me.m_getoutlen = DirectCast(RenardChipiplexer_21.VirtualSerialPort.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length), PluginWrapper.GetAndClearOutbuflen)
'					Return
				Case vopi.Name.Contains(" effects "):
					Me.m_OutputPlugin = New MyFx.CustomFx() 'FxGen_21.FxGen.VixFxGenPlugin()
'					Me.m_getoutlen = DirectCast(RenardChipiplexer_21.VirtualSerialPort.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length), PluginWrapper.GetAndClearOutbuflen)
					Return
#End If
				Case vopi.Name.StartsWith("Renard (chipiplexed)"):
					Me.m_OutputPlugin = New RenardChipiplexer_21.RenardChipiplexerPlugin()
'					Me.m_getoutlen = DirectCast(RenardChipiplexer_21.VirtualSerialPort.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length), PluginWrapper.GetAndClearOutbuflen)
					Return
				Case vopi.Name.StartsWith("Renard-RGB "):
					Me.m_OutputPlugin = New RenardRGB_21.RenardRGBPlugin()
'					Me.m_getoutlen = RenardRGB_21.VirtualSerialPort.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length)
					Return
			End Select
		End If
#End If
#If True 'fall-back: generic handler
'this assumes that there are fewer plug-ins than DLLs, so plug-ins are checked before DLLs:
		Dim folders As New List(Of String)
		folders.Add(System.IO.Path.Combine(System.IO.Path.Combine(System.IO.Path.GetDirectoryName(myexe), "Plugins"), "Output"))
		If System.IO.Path.GetFileNameWithoutExtension(myexe) <> "Vixen" Then 'alternate locations for easier debug
'			folders.Add(System.IO.Path.Combine(System.IO.Path.Combine(System.Environment.CurrentDirectory, "Plugins"), "Output"))
			folders.Add(System.IO.Path.GetDirectoryName(myexe))
			folders.Add(System.Environment.CurrentDirectory)
		End If
		For where As Integer = 1 To folders.Count
'			If (where > 0) And (folders(1) = folders(0)) Then Continue For
'too verbose			If Logger.WantTrace Then Logger.LogMsg(String.Format("Looking for {0} dll in '{1}'", vopi.Name, folders(where - 1)))
			Dim dllfolder As String = folders(where - 1) 'System.IO.Path.Combine(System.IO.Path.Combine(folders(where), "Plugins"), "Output") 'folder containing output plugin DLLs
			If Not System.IO.Directory.Exists(dllfolder) Then Continue For
'			If Me.m_logger.WantTrace Then Me.m_logger.LogMsg(String.Format("Load output plug-ins from folder {0}", dllfolder))
'this assumes that there are fewer plug-ins than DLLs, so plug-ins are checked before DLLs:
'			Dim dllfolder As String = System.IO.Path.Combine(System.IO.Path.Combine(System.IO.Path.GetDirectoryName(Process.GetCurrentProcess().MainModule.FileName), "Plugins"), "Output") 'folder containing output plugin DLLs
'			Dim dllfolder As String = System.IO.Path.Combine(System.IO.Path.Combine(System.IO.Directory.GetCurrentDirectory(), "Plugins"), "Output") 'folder containing output plugin DLLs
			If Logger.WantTrace Then Logger.LogMsg(String.Format("Looking for {0} in '{1}'", vopi.Name, dllfolder))
			For Each dll As String In System.IO.Directory.GetFiles(dllfolder, "*.dll", System.IO.SearchOption.TopDirectoryOnly)
				Try
10:					Dim foundself As Boolean = False
11:					For Each plugtype As Type In System.Reflection.Assembly.LoadFile(dll).GetExportedTypes()
12:						If plugtype.Name = Me.GetType.Name Then foundself = True: Exit For
					Next plugtype
14:					If foundself Then Continue For 'skip self
					For Each plugtype As Type In System.Reflection.Assembly.LoadFile(dll).GetExportedTypes()
'						If plugtype.GetInterface("IOutputPlugIn") Is Nothing Then Continue For 'not an output plug-in
						If plugtype.GetInterface("IEventDrivenOutputPlugIn") Is Nothing Then Continue For 'not an output plug-in
'						If plugtype.Name <> opi.GetType.Name Then Continue For
						Try
'LogMsg("try " & plugtype.Name & " for " & vopi.Name)
							Dim plugin As Vixen.IEventDrivenOutputPlugIn = DirectCast(Activator.CreateInstance(plugtype), Vixen.IEventDrivenOutputPlugIn)
'New Object() {name, id, enabled, stchannel, enchannel}
'LogMsg("now try " & plugin.Name & " for " & vopi.Name)
'							console.WriteLine("{0}:{1} vs {2}:{3}", plugin.Name, plugin.GetType.Name, opi.Name, opi.GetType.name)
							If plugin.Name <> vopi.Name Then Continue For 'don't know until instantiation if it matches or not
27:							Me.Desc = String.Format("{0} [{1}: {2}..{3}]", vopi.Name, vopi.Id, vopi.ChannelFrom, vopi.ChannelTo)
							Me.m_OutputPlugin = plugin
							If Logger.WantTrace Then Logger.LogMsg(String.Format("plug-in '{0}' loaded from dll '{1}'", Me.Desc, dll))
							Return
						Catch exc As Exception
'too verbose							If Logger.WantTrace Then Logger.LogMsg(String.Format("can't load plug-in type '{0}' from dll '{1}': {2} @{3}, skipping it", plugtype.Name, dll, exc.ToString, Erl))
							Continue For 'something wrong with this one, so just skip it
						End Try
					Next plugtype
				Catch exc As Exception
'too verbose					If Logger.WantTrace Then Logger.LogMsg(String.Format("can't load plug-in dll '{0}': {1} @{2}", dll, exc.ToString, Erl))
				End Try
			Next dll
		Next where
#End If
		Throw New Exception(String.Format("Can't create Output Plug-in for Event Driven Output Plugin '{0}'", vopi.Name))
	End Sub

	Private Shared getid As New RegularExpressions.Regex("\[(\d+):\s*\d+\.\.\d+\]$")
	Public Shared Function IdFromDesc(desc As String) As Integer
'		Me.Desc = String.Format("{0} [{1}: {2}..{3}]", vopi.Name, vopi.Id, vopi.ChannelFrom, vopi.ChannelTo)
		If String.IsNullOrEmpty(desc) Then Return -1
		Dim parts As Match = getid.Match(desc)
		If Not parts.Success OrElse (parts.Groups.Count <> 1+1) Then Return -1
'		logger.LogMsg(String.Format("id '{0}' fr desc '{1}'", parts.Groups(1).Value, desc))
		Return Integer.Parse(parts.Groups(1).Value)
	End Function

	Private Const MyPlugins As String = "MappedPlugin"
	Public Sub UpdateConfig(node As XmlNode, applyfx As Boolean, pixtype As String, geom As System.Drawing.Size, chorder As String, pitag As String)
		node = Vixen.Xml.SetNewValue(node, MyPlugins, String.Empty) 'always start with new node
'set plug-in attrs for new node:
		For Each attr As XmlAttribute In Me.m_node.Attributes
			If attr.Name = "key" Then Continue For 'don't need this one?
			Vixen.Xml.SetAttribute(node, attr.Name, attr.Value)
		Next attr
'		Vixen.Xml.SetAttribute(opnode, "to", Me.EndChannel)
'		Vixen.Xml.SetAttribute(opnode, "enabled", Me.Enabled)
'		Vixen.Xml.SetAttribute(opnode, "from", .VirtStartChannel)
'add config params:
		Vixen.Xml.SetValue(node, "WantFx", applyfx.ToString())
		Vixen.Xml.SetValue(node, "PixelType", pixtype)
		Vixen.Xml.SetValue(node, "Geometry", Size2String(geom))
		Vixen.Xml.SetValue(node, "ChannelOrder", chorder)
		Vixen.Xml.SetValue(node, "Tag", pitag)
'		Logger.LogMsg(String.Format("upd cfg: wantfx {0}, tag '{1}'", applyfx, pitag))
	End Sub

	Public Shared PrevChild As Windows.Forms.Form = Nothing 'KLUDGE: force plug-in window to show (if there is one); needed for Adjustable Preview, Grid Editor, etc.
	Public Sub Startup()
'		If Me.m_Enabled = False Then Return
'		Me.m_outhook = SafeDirectCast(Me.m_OutputPlugin, XSPlayer.IOutbufHook.GetType())
		Try
'			Me.m_outhook1 = Directcast(Me.m_OutputPlugin, Renard.XSPlayer.IOutbufHook)
'			If Me.m_outhook1 IsNot Nothing Then Me.m_outhook1.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length)
'		Catch exc As Exception
'			Me.m_outhook1 = Nothing
'		End Try
'		Try
'			Me.m_outhook2 = DirectCast(Me.m_OutputPlugin, RenardChipiplexer_21.XSPlayer.IOutbufHook)
'			If Me.m_outhook2 IsNot Nothing Then Me.m_outhook2.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length)
'		Catch exc As Exception
'			Me.m_outhook2 = Nothing
'		End Try
'		Try
'			Me.m_outhook3 = DirectCast(Me.m_OutputPlugin, RenardRGB_21.XSPlayer.IOutbufHook)
'			If Me.m_outhook3 IsNot Nothing Then Me.m_outhook3.SetBuffer(Me.Outbuf, 0, Me.Outbuf.Length)
'		Catch exc As Exception
'			Me.m_outhook3 = Nothing
'		End Try
'msgbox("TODO: open virt port here")
'alternating channel input buffers for more efficient dedup:
10:		Me.m_inbuf(0) = New Byte(Me.EndChannel - Me.StartChannel +0) {}
11:		Me.m_inbuf(1) = New Byte(Me.EndChannel - Me.StartChannel +0) {}
12:		PrevChild = Nothing 'Me.m_childform = Nothing
13:		If Logger.WantTrace Then Logger.LogMsg(String.Format("init+startup plug-in '{0}'", Me.Desc))
14:		Me.m_OutputPlugin.Initialize(Me.m_seq, Me.m_seq.PlugInData, Me.m_node)
15:		Me.m_OutputPlugin.Startup()
16:		If Me.WantFx Then Me.Canvas = Me.Map(Me.FrameBuf, Me.StartChannel -1, Me.EndChannel - Me.StartChannel +1) '//generate GDI bitmap to draw on
17:		Me.m_childform = PrevChild
18:		If Me.m_childForm IsNot Nothing Then Me.m_childForm.Show() 'force visible plug-ins to show (Adjustable Preview, Grid Editor, etc)
'19:		If Logger.WantTrace Then Logger.LogMsg(String.Format("... init+startup plug-in '{0}'", Me.Desc))
		Catch exc As Exception
			Logger.ReportError("Plugin.Startup", exc)
		End Try
	End Sub

	Public Function NextInbuf() As Byte()
		Return Me.m_inbuf(Me.m_inff And 1) 'alternate input buffers ro reduce array copying and for more efficient frame dedup
	End Function

'	Public Sub SendEvent(seq As Vixen.EventSequence, frame As Integer) 'channels As Byte())
	Public Sub SendEvent(frbuf As Byte()) ', frame As Integer) 'channels As Byte())
'TODO: allow filter/chain and reuse input buffers
'no-TODO: dynamically generate channel inputs here (FxGen)
'		Me.m_inff += 1 'alternate input buffers for more efficient frame dedup
'		For ch As Integer = Me.m_StartChannel To Me.m_EndChannel
'			Me.m_inbuf(Me.m_inff And 1) (ch - Me.m_StartChannel) = seq.EventValues(ch -1, frame -1)
'		Next ch
'		If Me.m_outhook IsNot Nothing Then Me.m_outhook.GetOutbufLen(True)
'alternate input buffers for more efficient frame dedup:
		Dim inbuf As Byte() = Me.NextInbuf()
		If frbuf IsNot Nothing Then System.Array.Copy(frbuf, Me.StartChannel -1, inbuf, 0, Me.EndChannel - Me.StartChannel + 1)
'		If Logger.WantTrace Then Logger.LogMsg(String.Format("Send channel values[{0}..{1}] to '{2}', refr? {3}, frbuf# {4}: ", Me.StartChannel, Me.EndChannel, Me.m_OutputPlugin.Name, Me.m_childForm IsNot Nothing, Me.m_inff) & Logger.DumpHex(frbuf, Me.StartChannel -1, Me.EndChannel - Me.StartChannel + 1, 12* 250))
'		If Logger.WantTrace Then Logger.LogMsg(String.Format("Send channel values[{0}..{1}] to '{2}', refr? {3}, frbuf# {4}: ", Me.StartChannel, Me.EndChannel, Me.m_OutputPlugin.Name, Me.m_childForm IsNot Nothing, Me.m_inff) & Logger.DumpHex(inbuf, 0, inbuf.Length, 12* 250))
		Me.m_OutputPlugin.[Event](inbuf) 'New ByteRange(channels, Me.m_StartChannel - 1, Me.m_EndChannel - Me.m_StartChannel + 1).Bytes)
		If Me.m_childForm IsNot Nothing Then Me.m_childForm.Refresh()
		Windows.Forms.Application.DoEvents()
		Me.m_inff += 1 'alternate input buffers for more efficient frame dedup
'		If Me.m_outhook1 IsNot Nothing Then Me.Outlen = Me.m_outhook1.GetOutbufLen(True)
'		If Me.m_outhook2 IsNot Nothing Then Me.Outlen = Me.m_outhook2.GetOutbufLen(True)
'		If Me.m_outhook3 IsNot Nothing Then Me.Outlen = Me.m_outhook3.GetOutbufLen(True)
'TODO: grab output from virt port here if frame will be pre-rendered
'		LogMsg(String.Format("Send frame {0} output from {1}: ", frame, Me.m_OutputPlugin.Name) & DumpHex(Me.Outbuf, 0, Me.Outlen, 2000))
	End Sub

	Public Sub Shutdown()
		If Logger.WantTrace Then Logger.LogMsg(String.Format("shutdown plug-in '{0}'", Me.Desc))
		If Me.m_childForm IsNot Nothing Then Me.m_childForm.Hide()
		Me.m_OutputPlugIn.Shutdown()
	End Sub

'max buf size for a given baud rate and frame rate:
'	Public Shared Function BufSize(baud As Integer, interval As Integer) As Integer
'		Return CInt(baud/10/(1000/interval))
'	End Function

#If False 'BROKEN
	Private Function FindType(inst As Object, name As String) As Type
		Dim sb As New StringBuilder()
		For Each exptype As Type In inst.GetType().Assembly.GetExportedTypes()
			sb.AppendFormat(", {0}", exptype.Name)
			If exptype.Name = name Then Return exptype
		Next exptype
'		msgbox(sb.ToString())
		Throw New Exception(String.Format("Can't find type '{0}' in assembly, choices are: {2}", name, sb.ToString().subString(2)))
	End Function
#End If

'	Delegate Sub LogMsgDelegate(msg As String, flush As LogMode)
'	Public Shared Logger As LogMsgDelegate
'	Private Sub LogMsg(buf As String) 'delegates don't like optional params, so overload it
'		LogMsg(buf, LogMode.Silent)
'	End Sub
'	Private Sub LogMsg(buf As String, mode As LogMode)
'		Logger(buf, mode)
'	End Sub

End Class


'channel mapper:
'Maps channel array <-> GDI+ bitmap
Public Partial Class FxGenPluginBase
	Public WantFx As Boolean = False
	Public PluginTag As String = String.Empty
	Public Canvas As System.Drawing.Bitmap = Nothing 'Vixen channels are mapped to a GDI+ bitmap

	Public Function Map(br As ByteRange) As System.Drawing.Bitmap
		Return Me.Map(br.Bytes, br.StartOfs, br.AvailLen)
	End Function
	Public Function Map(channels as Byte()) As System.Drawing.Bitmap
		Return Me.Map(channels, 0, channels.Length, Nothing)
	End Function
	Public Function Map(channels As Byte(), ofs As Integer, len As Integer) As System.Drawing.Bitmap
		Return Me.Map(channels, ofs, len, Nothing)
	End Function
	Public MustOverride Function Map(channels As Byte(), ofs As Integer, len As Integer, dest As System.Drawing.Bitmap) As System.Drawing.Bitmap

	Public Function Unmap(bmp As System.Drawing.Bitmap) As Byte()
		Return Me.Unmap(bmp, Nothing, 0, 3 * Me.Geometry.Width * Me.Geometry.Height) 'assume RGB
	End Function
	Public Function Unmap(bmp As System.Drawing.Bitmap, br As ByteRange) As Byte()
		Return Me.Unmap(bmp, br.Bytes, br.StartOfs, br.AvailLen)
	End Function
	Public Function Unmap(bmp As System.Drawing.Bitmap, dest As Byte()) As Byte()
		Return Me.Unmap(bmp, dest, 0, dest.Length)
	End Function
	Public MustOverride Function Unmap(bmp As System.Drawing.Bitmap, dest As Byte(), ofs As Integer, len As Integer) As Byte()

	Public NumChannels As Integer = 0

	Public PixelType As String = String.Empty
	Public MustOverride Function PixelTypes() As List(Of String) 'ReadOnly Property 
		
	Public Geometry As New System.Drawing.Size(0, 0)
	Public MustOverride Function Geometries() As List(Of System.Drawing.Size) 'ReadOnly Property 
		
	Public ChannelOrder As String = String.Empty
	Public MustOverride Function ChannelOrders() As List(Of String) 'ReadOnly Property 

	Public Shared Function Size2String(wh As System.Drawing.Size) As String
		Return String.Format("{0} x {1}", wh.Width, wh.Height)
	End Function

	Public Shared Function String2Size(wh As String) As System.Drawing.Size
		Dim ofs As Integer = wh.IndexOf("x")
		If ofs < 0 Then Return New System.Drawing.Size(0, 0)
		Return New System.Drawing.Size(Convert.ToInt32(wh.Substring(0, ofs).Trim()), Convert.ToInt32(wh.Substring(ofs+1).Trim()))
'		Catch exc As Exception
'			Me.m_logger.ReportError(String.Format("invalid size string: {0}", whstr), exc)
'			Return New Size(0, 0)
'		End Try
	End Function
End Class


'array subset:
Public Class ByteRange
	Public Bytes As Byte()
	Public StartOfs As Integer, AvailLen As Integer

	Public Sub New(buf As Byte(), stofs As Integer, len As Integer)
'#If True 'shift/truncate
'			this.Bytes = New Byte(len -1) {}
'			System.Array.Copy(buf, stofs, this.Bytes, 0, len)
'#else 'in-place; avoids extra copying
		Me.Bytes = buf
		If (buf Is Nothing) And (len > 0) Then Me.Bytes = New Byte(len) {}
		Me.StartOfs = stofs
		Me.AvailLen = len
'#End If
	End Sub
End Class

End Namespace 'FxGen


#Region "junk"
'collection class with additional methods to call all items in the list:
'needs to be a separate class rather than shared on PLuginWrapper to allow multiple copies (XSPlayer vs. FxGen)
#If False
Public Class ListOf_PluginWrapper'(Of String, PluginWrapper)
	Inherits List(Of PluginWrapper)

'cumulative properties:
	Public MinChannel As Integer = Int32.MaxValue, MaxChannel As Integer = 0

	Public Function AllocFramebuf() As Byte()
		Dim numch As Integer = Me.MaxChannel - Me.MinChannel + 1
'		msgbox(string.Format("aloc frame buf {0}", PluginWrapper.MaxChannel - PluginWrapper.MinChannel))
		Return New Byte(numch - 1) {} 'allow trailing B + G on RGB values
	End Function

	Public Function LoadPlugins(virtseq As Vixen.IExecutable, hostnode As XmlNode) As Boolean
		MyBase.Clear() 'start with empty list
'		PluginWrapper.Logger = AddressOf XSPlayer.LogMsg
'		msgbox("set up virt ser port")
		For Each vopi As Vixen.OutputPlugin In virtseq.PlugInData.GetOutputPlugins
'			If vopi.Name <> plugin.ToString Then Continue For 'looking for plug-in by name
			Dim piw As New PluginWrapper(virtseq, vopi, virtseq.PlugInData.GetPlugInData(vopi.Id.ToString(), hostnode.SelectSingleNode(String.Format("Plugin[@id='{0}']", Mvopi.Id.ToString)))
'alloc frame buffer even for disabled plugins (avoids conditional offsets):
			Me.MinChannel = Math.Min(piw.StartChannel, Me.MinChannel)
			Me.MaxChannel = Math.Max(piw.EndChannel, Me.MaxChannel)
			If Not piw.Enabled Then Continue For
			MyBase.Add(piw)
		Next vopi
//			this.m_chmap = new MyChannelMapper();
//			this.m_chmap.PixelType = "RGB";
//			this.m_chmap.Geometry = new Size(16, 15);
//			this.m_chmap.ChannelOrder = "LR-BT";
//			this.m_macofs = (int)MyVirtChannels.MacroFunc;
//			this.m_frbofs = frbuf.StartOfs;
//			this.m_frblen = frbuf.AvailLen;
//		 (int)MyVirtChannels.GdoorRChofs, (int)MyVirtChannels.GdoorRNumch, "RGB", new Size(16, 15), "LR-BT");
//			this.m_canvas = this.m_chmap.Map(frbuf); //GDI bitmap to draw on
//			this.m_gr = Graphics.FromImage(this.m_canvas);
//			this.m_rect = new Rectangle(0, 0, this.m_chmap.Geometry.Width, this.m_chmap.Geometry.Height);
//			this.m_wh = new Size(Math.Min(Math.Max(this.m_chmap.Geometry.Width, 2), 20), Math.Max(this.m_chmap.Geometry.Height, 2));
		Return MyBase.Count > 0
	End Function

	Public Sub StartPlugins(seq As Vixen.IExecutable)
		For Each vopiw As PluginWrapper In Me
			vopiw.Startup()
		Next vopiw
	End Sub

	Public Sub SendPlugins(frbuf As Byte()) ', frame As Integer) 'channels As Byte())
		For Each vopiw As PluginWrapper In Me
			vopiw.SendEvent(frbuf)
		Next vopiw
	End Sub

	Public Sub StopPlugins(seq As Vixen.IExecutable)
		For Each vopiw As PluginWrapper In Me
			vopiw.Shutdown()
		Next vopiw
	End Sub

#If false 'old code
	Public Sub UpdateCounts
		Me.SelectedCount = 0
		Me.MinChannel = Int32.MaxValue 'force updates
		Me.MaxChannel = 0 'force updates
		For i As Integer = 1 To Me.Count
			With Me.Values(i - 1)
				If .VirtEnabled Then Me.SelectedCount += 1 '.Selected?
				Me.MinChannel = Math.Min(.VirtStartChannel, Me.MinChannel)
				Me.MaxChannel = Math.Max(.VirtEndChannel, Me.MaxChannel)
			End With
		Next i
	End Sub

'	Public ReadOnly Property SelectedCount As Integer
'		Get
'			Dim numsel As Integer = 0
'			For i As Integer = 1 To Me.Count
'				If Me.Values(i - 1).Selected Then numsel += 1
'			Next i
'			Return numsel
'		End Get
'	End Property
'
'	Public ReadOnly Property MinChannel As Integer
'		Get
'			Dim minch As Integer = Int32.MaxValue
'			For i As Integer = 1 To Me.Count
'				minch = Math.Min(Me.Values(i - 1).RealStartChannel, minch)
'			Next i
'			Return minch
'		End Get
'	End Property
'
'	Public ReadOnly Property MaxChannel As Integer
'		Get
'			Dim maxch As Integer = 0
'			For i As Integer = 1 To Me.Count
'				maxch = Math.Max(Me.Values(i - 1).RealEndChannel, maxch)
'			Next i
'			Return maxch
'		End Get
'	End Property

'safer Add:
'	Public Overloads Sub Add(key As String, val As PlugInfo)
'		Dim sb As New StringBuilder
'		For Each k As String In MyBase.Keys
'			sb.AppendFormat(", '{0}'", k)
'		Next k
'		If MyBase.ContainsKey(key) Then Throw New Exception(String.Format("key '{0}' already exists in {1}:{2}", key, MyBase.Count, sb.ToString(2, sb.Length - 2)))
'		MyBase.Add(key, val)
'	End Sub

'Vixen event handling:
	Public Sub StartupAll()
		For i As Integer = 1 To Me.Count 'tell each plug-in to start up
			Me.Values(i - 1).Startup()
		Next i
	End Sub

	Public Sub EventOutAll(channels as Byte())
		For i As Integer = 1 To Me.Count 'tell each plug-in about the event
			Me.Values(i - 1).EventOut(channels, Me.MinChannel)
'				oplug.dispose(True)
		Next i
	End Sub

	Public Sub ShutdownAll()
		For i As Integer = 1 To Me.Count 'tell each plug-in to shut down
			Me.Values(i - 1).Shutdown()
		Next i
	End Sub
#End If
End Class
#End If

#If False
	Private Shared m_plugins As New List(Of PluginWrapper)
	Public Shared Function StartPlugins(seq As Vixen.IExecutable) As Boolean
		m_plugins.Clear()
'		PluginWrapper.Logger = AddressOf XSPlayer.LogMsg
'		msgbox("set up virt ser port")
		For Each vopi As Vixen.OutputPlugin In seq.PlugInData.GetOutputPlugins
'			If vopi.Name <> plugin.ToString Then Continue For 'looking for plug-in by name
			Dim piw As New PluginWrapper(seq, vopi, seq.PlugInData.GetPlugInData(vopi.Id.ToString()))
			If Not piw.Enabled Then Continue For
			m_plugins.Add(piw)
			piw.Startup()
		Next vopi
		Return m_plugins.Count > 0
	End Function

	Public Shared Sub SendPlugins(frbuf As Byte()) ', frame As Integer) 'channels As Byte())
		For Each vopiw As PluginWrapper In m_plugins
			vopiw.SendEvent(frbuf)
		Next vopiw
	End Sub

	Public Shared Sub StopPlugins(seq As Vixen.IExecutable)
		For Each vopiw As PluginWrapper In m_plugins
			vopiw.Shutdown()
		Next vopiw
	End Sub
#End If
#End Region
